[leetcode]Distinct Subsequences @ Python

原题地址:https://oj.leetcode.com/problems/distinct-subsequences/

题意:

Given a string S and a string T, count the number of distinct subsequences of T in S.

A subsequence of a string is a new string which is formed from the original string by deleting some (can be none) of the characters without disturbing the relative positions of the remaining characters. (ie, "ACE" is a subsequence of "ABCDE" while "AEC" is not).

Here is an example:
S = "rabbbit"T = "rabbit"

Return 3.

解题思路:这道题使用动态规划来解决。题的意思是:S的所有子串中,有多少子串是T。下面来看看状态转移方程。dp[i][j]表示S[0...i-1]中有多少子串是T[0...j-1]。

当S[i-1]=T[j-1]时:dp[i][j]=dp[i-1][j-1]+dp[i-1][j];

      S[0...i-1]中有多少子串是T[0...j-1]包含:{S[0...i-2]中有多少子串是T[0...j-2]}+{S[0...i-2]中有多少子串是T[0...j-1]}

当S[i-1]!=T[j-1]时:dp[i][j]=dp[i-1][j-1]

初始化状态如何确定呢:

 dp[0][j]=0;因为:S是空串,则无论如何都不能包含非空的子串。这个初始状态在初始化矩阵dp的时候就顺带包括了

 dp[i][0]=1;因为:S[0...i-1]只有一个子串是空串。

代码:

class Solution:
    # @return an integer
    def numDistinct(self, S, T):
        dp = [ [0 for j in range(len(T) + 1)] for i in range(len(S) + 1) ]
        for i in range(len(S) + 1):
            dp[i][0] = 1
            
        for i in range(1, len(S) + 1):
            for j in range(1, len(T) + 1):
                if S[i - 1] == T[j - 1]:
                    dp[i][j] = dp[i-1][j-1] + dp[i-1][j]
                else:
                    dp[i][j] = dp[i-1][j]
        return dp[len(S)][len(T)]
原文地址:https://www.cnblogs.com/asrman/p/4009924.html